define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");

	var Model = function(){
		this.callParent();
		this.isSaveDataBtn = justep.Bind.observable(false); // 设置保存按钮不可用
//		this.saveDataRowIdFromSet = new Set();
	};
	
	/** ------感知事件---------------- **/
	/** 页面初始化完成 */
	Model.prototype.modelLoad = function(event){
		var tabsLabel = this.comp("tabs").$domNode.find(".active").children("a").html(); // 获取当前tabs激活的页签
		var mainData = this.comp("mainData");
		mainData.setFilter("categoryFilter", "tab_S_SalaryStandards.sCategory='岗位'");
		mainData.setFilter("personCategoryFilter", "tab_S_SalaryStandards.sPersonCategory like '%"+tabsLabel+"%'");
		mainData.refreshData();
	};
	/** 页面激活 */
	Model.prototype.modelActive = function(event){
		var tabsLabel = this.comp("tabs").$domNode.find(".active").children("a").html(); // 获取当前tabs激活的页签
		var mainData = this.comp("mainData");
		mainData.setFilter("personCategoryFilter", "tab_S_SalaryStandards.sPersonCategory like '%"+tabsLabel+"%'");
		mainData.refreshData();
	};
	/** data保存成功 */
	Model.prototype.saveCommit = function(event){
		justep.Util.hint("保存成功！", {type: 'success', parent: this.getRootNode()});
	};
	/** 感知mainData变化 */
	Model.prototype.perceptionMainDataChange = function(event){
		this.isSaveDataBtn.set(true); // 设置保存按钮可用
		// 将变化的DataID存入set数据集以便更新
		var mainData = this.comp("mainData");
		var	rowID = mainData.getRowID();
//		this.saveDataRowIdFromSet.add(rowID);
	};

	/** ------按钮点击事件---------------- **/
	/** 管理 标签页点击事件 */
	Model.prototype.GL_liClick = function(event){
		var mainData = this.comp("mainData");
		mainData.setFilter("personCategoryFilter", "tab_S_SalaryStandards.sPersonCategory like '%管理%'");
		mainData.refreshData();
	};
	/** 管理 新增 */
	Model.prototype.GL_NewClick = function(event){
		this.newMainData("岗位", "管理");
	};
	
	/** 技术 标签页点击事件 */
	Model.prototype.JS_liClick = function(event){
		var mainData = this.comp("mainData");
		mainData.setFilter("personCategoryFilter", "tab_S_SalaryStandards.sPersonCategory like '%技术%'");
		mainData.refreshData();
	};
	/** 技术 新增 */
	Model.prototype.JS_NewClick = function(event){
		this.newMainData("岗位", "技术");
	};
	
	/** 工勤 标签页点击事件 */
	Model.prototype.GQ_liClick = function(event){
		var mainData = this.comp("mainData");
		mainData.setFilter("personCategoryFilter", "tab_S_SalaryStandards.sPersonCategory like '%工勤%'");
		mainData.refreshData();
	};
	/** 工勤 新增 */
	Model.prototype.GQ_NewClick = function(event){
		this.newMainData("岗位", "工勤");
	};

	/** 保存mainData */
	Model.prototype.saveMainDataClick = function(event){
		var mainData = this.comp("mainData");
		var meContext = this.getContext();
		
		// 遍历数据改变过的 DataID
//		this.saveDataRowIdFromSet.forEach(function(rowID) {
//			mainData.setValueByID("sUpdatePerson", meContext.getCurrentPersonName(), rowID); // 更新人
//			mainData.setValueByID("sUpdatePersonID",  meContext.getCurrentPersonID(), rowID); // 更新人ID
//			mainData.setValueByID("sUpdateDept", meContext.getCurrentDeptName(), rowID); // 更新人部门
//			mainData.setValueByID("sUpdateDeptID", meContext.getCurrentDeptID(), rowID); // 更新人部门ID
//			mainData.setValueByID("sUpdateTime", new Date(), rowID); // 更新时间
//		});
		mainData.saveData();
		this.isSaveDataBtn.set(false); //  设置保存按钮不可用
//		this.saveDataRowIdFromSet.clear(); // 保存之后删除所有保存数据
		mainData.refreshData();
	};
	
	/** ------函数事件---------------- **/
	/** 保存mainData */
	Model.prototype.newMainData = function(category, personCategory){
		var mainData = this.comp("mainData");
		mainData.newData();
		mainData.setValue("sCategory", category); // 分类
		mainData.setValue("sPersonCategory", personCategory); // 适用人员种类
	};

	return Model;
});